/*
 * Provide 'wrapper' for analog's init.c module that works around lack
 * of gettimeofday() function (and timeval struct if VAXC).
 */
struct timezone {
    int offset, isdst;
    char *tz;
};
#ifdef VAXC
struct timval { long tv_sec, tv_usec; };
#endif
#define __TIMEZONE
#include <time.h>
#include <descrip.h>

int gettimeofday ( struct timeval *tp, struct timezone *tzp )
{
    long now[2], unix_now[2], a,b, divisor;
    static long base_time[2] = { 0, 0};
    static $DESCRIPTOR(base_time_str,"1-JAN-1970 00:00:00");
    int status, SYS$GETTIM(), SYS$BINTIM(), LIB$EDIV(), LIB$SUBX();

    if ( !base_time[0] ) SYS$BINTIM ( &base_time_str, &base_time );
    status = SYS$GETTIM ( now );
    LIB$SUBX ( now, base_time, unix_now );
    divisor = 10000000;			/* Converts 100-nanosec to seconds */
    LIB$EDIV ( &divisor, unix_now, &tp->tv_sec, &tp->tv_usec );
    tp->tv_usec = tp->tv_usec / 10;     /* Convert 100-nanosec to usec */
    return 0;
}

#include "init.c"
